<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Donateur extends Model
{
    use SoftDeletes;

    protected $fillable = ['nom','prenom','sexe','email','telephone','fonction', 'fedapay_id'];

    public function groups()
    {
        return $this->belongsToMany(Group::class, 'donateur_group');
    }

    public function links()
    {
        return $this->hasMany(Link::class);
    }

    public function payments()
    {
        return $this->hasManyThrough(
            Payment::class,  // Modèle des paiements
            Link::class,     // Modèle intermédiaire
            'donateur_id',   // Clé étrangère sur la table links
            'link_id',       // Clé étrangère sur la table payments
            'id',            // Clé locale du donateur
            'id'             // Clé locale du lien
        );
    }
}

